<?php
class C {
    private $prop1, $prop2;
    public function __construct($prop1, $prop2) {
        $this->prop1 = $prop1;
        $this->prop2 = $prop2;
    }
    public static function compareTo(
        self $obj1, self $obj2
    ) {
        return [$obj1->prop1, $obj1->prop2]
            <=> [$obj2->prop1, $obj2->prop2];
    }
    public static function sort(array $ary) {
        usort($ary, [self::class, 'compareTo']);
        return $ary;
    }
}

$obj1 = new C(2, 2);
$obj2 = new C(1, 1);
$obj3 = new C(1, 4);
var_dump(C::sort([$obj1, $obj2, $obj3]));

